import { defineNuxtConfig } from 'nuxt/config'

import sitemapRoutes from './sitemapRoutes'
// https://v3.nuxtjs.org/api/configuration/nuxt.config
export default defineNuxtConfig({
  nitro: {
    firebase: {
      gen: 2
      // ...
    },
    routeRules: {
      "/_nuxt/**": { headers: { "cache-control": "max-age=31536000" } }, // Set generated files cache to 1 year
    },
  },
  app: {
  head: {
    htmlAttrs: {
      lang: 'en'
    },
    link: [
      { rel: 'icon', type: 'image/x-icon', href: 'https://ik.imagekit.io/choreless/v0/b/tr:q-10,w-150/choreless-bb99d.appspot.com/o/Ch%20icon%20red%20%20(2).svg?alt=media&token=fcf9e3e2-03c2-40fe-92c1-4b68e8bec5f0' }
    ]
  },
}, routeRules: {
 
  '/_nuxt/**': { headers: { 'cache-control': 's-maxage=31536000' } },
  
},
  env: {
    projectEnviroment: process.env.projectEnviroment,
    projectEnviromentURL: process.env.projectEnviromentURL,
    NODE_ENV:  'production'

  },
  modules: ['nuxt-jsonld','@nuxt/content'],
  extendRoutes (routes) {
    routes.push({name: 'logout', path: '/logout', component: '~portal/pages/logout.vue'})
   
  },
 
 
  ssr: true,
  target: 'server',
 
  
  
  head: {
  
    // meta: [
    //   {
    //     hid: 'description',
    //     name: 'description',
    //     content: "2022's top Wash & Fold service in SEA. With free pick-up and delivery in SEA, trust Choreless with all of your laundry needs! Let us stay on top of your laundry while you focus on what you love!"
    //   }
    // ],
    link: [
      { rel: 'icon', type: 'image/x-icon', href: 'https://ik.imagekit.io/choreless/v0/b/tr:q-10,w-150/choreless-bb99d.appspot.com/o/Ch%20icon%20red%20%20(2).svg?alt=media&token=fcf9e3e2-03c2-40fe-92c1-4b68e8bec5f0' }
    ]
  },
  
  
  css: [
    '~/assets/style.css',
    '~/assets/gp-custom.css',
    '~/assets/gp-custom-mobile.css',
    '~/assets/gp-common.css'
  ],



})
